//////////////////////////////////
//															//
//	NameSpace, HW #1  					//
//															//
//  Chungho Chau								//
//															//
//////////////////////////////////

#include <iostream.h>


namespace Integers
{
	int x,y;
	int Add(int a, int b)				{ return a+b; } 
	int Multiple(int a, int b)	{ return a*b; }
	void Print(int a, int b)
		{ cout << "Integers are " << a << " and " << b << endl; }
}

namespace Floats
{
	float x,y;
	float Add(float a, float b)				{ return a+b; } 
	float Multiple(float a, float b)	{ return a*b; }
	void Print(float a, float b)
		{ cout << "Integers are " << a << " and " << b << endl; }
}

namespace Characters  
{
	// ** implementation is done separately **
	char x,y;
	char Add(char, char);
	char Multiple(char, char);
	void Print(char, char);
}

void Header(void);


void main()
{
	char choice;
	
	using namespace Integers;
	using namespace Floats;
	using namespace Characters;
	
	Header();

	while ( (choice = cin.get() ) != EOF ) {
	
		switch (choice){
			
			case '1':				
				cout << "Enter two Integers: ";
				cin >> Integers::x >> Integers::y;
				cout << "Sum of two integers is " << Add(Integers::x, Integers::y) << endl;
				cout << "Multiple of two integers is " << Multiple(Integers::x, Integers::y)
						 << endl;
				Print(Integers::x, Integers::y);
				cout << endl;
			  Header();
				break;
			 
			case '2':
				cout << "Enter two Floats: ";
				cin >> Floats::x >> Floats::y;
				cout << "Sum of two floats is " << Add(Floats::x, Floats::y) << endl;
				cout << "Multiple of two floats is " << Multiple(Floats::x, Floats::y)
						 << endl;
				Print(Floats::x, Floats::y);
				cout << endl;
			  Header();
				break;

			case '3':
				cout << "Enter two Characters: ";
				cin >> Characters::x >> Characters::y;
				cout << "Sum of two characters is " << Add(Characters::x, Characters::y) << endl;
				cout << "Multiple of two characters is " << Multiple(Characters::x, Characters::y)
						 << endl;
				Print(Characters::x, Characters::y);
				cout << endl;
			  Header();
				break;

			case '\n':
			case '\t':
			case ' ':
				break;

			default:
				cout << "Invalid choice selected !!" << endl << endl;
				Header();
				break;
		}
	}	
}


// ================================== 
// Implementation for Header function
// ================================== 
void Header(void)
{
	cout << "+----------------------+" << endl;
	cout << "| Enter 1 for Integer  |" << endl;
	cout << "| Enter 2 for Float    |" << endl;
	cout << "| Enter 3 for Character|" << endl;
	cout << "| \"Crtl+Z\" to End      |" << endl;
	cout << "+ ---------------------+" << endl;
	cout << " Make a selection: ";
}


// ======================================= 
// Implementation for namespace Characters
// ======================================= 
char Characters::Add(char a, char b)
	{	return (char)(char(a) + char(b)); }

char Characters::Multiple(char a, char b)
  {	return (char)(char(a) * char(b)); }

void Characters::Print(char a, char b)
	{	cout << "Characters are " << a << " and " << b << endl; }

