//////////////////////////////////
//															//
//	NameSpace, HW #1  					//
//															//
//  Chungho Chau								//
//															//
//////////////////////////////////

#include <iostream.h>


namespace Integers
{
	int x,y;
	int AddInts(int, int);
	int MultInts(int, int);
	void PrintInts(int, int);
}

namespace Floats
{
	float x,y;
	float AddFloat(float, float);
	float MultFloat(float, float);
	void PrintFloat(float, float);
}

namespace Characters
{
	char x,y;
	char AddCharacter(char, char);
	char MultCharacter(char, char);
	void PrintCharacter(char, char);
}

void Header(void);

void main()
{
	char choice;
	
	using namespace Integers;
	using namespace Floats;
	using namespace Characters;
	
	Header();

	while ( (choice = cin.get() ) != EOF ) {
	
		switch (choice){
			
			case '1':				
				cout << "Enter two Integers: ";
				cin >> Integers::x >> Integers::y;
				cout << "Sum of two integers is " << AddInts(Integers::x, Integers::y) << endl;
				cout << "Multiple of two integers is " << MultInts(Integers::x, Integers::y) << endl;
				PrintInts(Integers::x, Integers::y);
				cout << endl;
			  Header();
				break;
			 
			case '2':
				cout << "Enter two Floats: ";
				cin >> Floats::x >> Floats::y;
				cout << "Sum of two floats is " << AddFloat(Floats::x, Floats::y) << endl;
				cout << "Multiple of two floats is " << MultFloat(Floats::x, Floats::y) << endl;
				PrintFloat(Floats::x, Floats::y);
				cout << endl;
			  Header();
				break;

			case '3':
				cout << "Enter two Characters: ";
				cin >> Characters::x >> Characters::y;
				cout << "Sum of two characters is " << AddCharacter(Characters::x, Characters::y) << endl;
				cout << "Multiple of two characters is " << MultCharacter(Characters::x, Characters::y) << endl;
				PrintCharacter(Characters::x, Characters::y);
				cout << endl;
			  Header();
				break;

			case '\n':
			case '\t':
			case ' ':
				break;

			default:
				cout << "none" << endl;
				break;
		}

	}
	
}

void Header(void)
{
	cout << "Enter 1 for Integer" << endl;
	cout << "Enter 2 for Float"   << endl;
	cout << "Enter 3 for Character" << endl;
	cout << "\"Crtl+Z\" to End" << endl << endl;
	cout << "Please make a selection: " << endl;
}

int Integers::AddInts(int a, int b)
{
	return a+b;
}


int Integers::MultInts(int a, int b)
{
	return a * b;
}


void Integers::PrintInts(int a, int b)
{
	cout << "Integers are " << a << " and " << b << endl;
}

float Floats::AddFloat(float a, float b)
{
	return a + b;
}

float Floats::MultFloat(float a, float b)
{
	return a * b;
}

void Floats::PrintFloat(float a, float b)
{
	cout << "Floats are " << a << " and " << b << endl;
}


char Characters::AddCharacter(char a, char b)
{
	return (char)(char(a) + char(b));
}

char Characters::MultCharacter(char a, char b)
{
	return (char)(char(a) * char(b));
}

void Characters::PrintCharacter(char a, char b)
{
	cout << "Characters are " << a << " and " << b << endl;
}